<?php
/*
Plugin Name: UnPointZero content Slider
Plugin URI: http://sliderWP.unpointzero.com
Description: A customizable slider for your featured content by UnPointZero WebAgency
Version: 1.0b
Author: Jordan Matejicek - UnPointZero
Author URI: http://www.UnPointZero.com
*/

/* On active les thumbs si elles ne sont pas activs par defaut...*/
if ( function_exists( 'add_theme_support' ) )
add_theme_support( 'post-thumbnails' );

/* Page d'options */
$options_page = get_option('siteurl') . '/wp-admin/admin.php?page=unpointzero-slider/Options.php';
/* Ajout de la page d'options dans l'administration Wordpress */
function slider_options_page() {
	add_options_page('UnPointZero Content Slider Options', 'UnPointZero Slider', 10, 'unpointzero-slider/Options.php');
}

/* Code necessaire au header du site pour bon fonctionnement du plugin */
function slider_styles() {
	$slider_path =  get_bloginfo('wpurl')."/wp-content/plugins/unpointzero-slider/";
	$sliderscript = "
    <link rel=\"stylesheet\" href=\"".$slider_path."css/slider.css\" type=\"text/css\" media=\"screen\" charset=\"utf-8\"/>
	<script type=\"text/javascript\" src=\"http://ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js\"></script>
	<script type=\"text/javascript\" src=\"http://ajax.googleapis.com/ajax/libs/jqueryui/1.5.3/jquery-ui.min.js\"></script>
	<script type=\"text/javascript\" src=\"".$slider_path."libs/slidercfg.js\"></script>
	";
	echo($sliderscript);
}

/* Rcuperation des posts souhaits 
	@param int category 				:	la catgorie du post
	@param int number 					:	le nombre de news  afficher
	@param int slider_title_max_char	:	le nb de caractres max pour les titres
	@param int slider_desc_max_char		:	le nb de caractres max pour les descriptions
*/
function slider_getinfo_by_cat($category,$number,$slider_title_max_char,$slider_desc_max_char) {
	global $post;
	$post_ids = array();
	
	// Rcuperation des options
	if(get_option('slider-bigthumb-x')!=null)
		$slider_bigthumb_x = get_option('slider-bigthumb-x');
	else
		$slider_bigthumb_x = 419;
	if(get_option('slider-bigthumb-y')!=null)
		$slider_bigthumb_y = get_option('slider-bigthumb-y');
	else
		$slider_bigthumb_y = 248;	
		
	if(get_option('slider-smallthumb-x')!=null)
		$slider_smallthumb_x = get_option('slider-smallthumb-x');
	else
		$slider_smallthumb_x = 85;
	if(get_option('slider-smallthumb-y')!=null)
		$slider_smallthumb_y = get_option('slider-smallthumb-y');
	else
		$slider_smallthumb_y = 50;		
		

	if($category!="" || $category!=0) {
	$category = "&category_name=".$category;
	}
	else {
	$category = "";
	}
	$myposts = get_posts("numberposts=$number$category");
	
	foreach($myposts as $post) :
		$post_ids[] = $post->ID;
		
		$title = "";
		if (strlen($post->post_title) > $slider_title_max_char) { 
				$title = substr($post->post_title, 0, $slider_title_max_char); 
				$position_espace = strrpos($title, " "); 
				$title = substr($title, 0, $position_espace); 
				$title = $title."...";
			}
		else $title = $post->post_title;
		
		$post_title[] = $title;
		
		$content = "";
	
		
		if (strlen($post->post_content) > $slider_desc_max_char) { 
				$pattern = '(?<=^|>)[^><]+?(?=<|$)';
				$content = preg_replace("#\[.*?\]#", "", $post->post_content);
				
				$content = strip_tags($content,'<p>');
				$content = substr($content, 0, $slider_desc_max_char); 
				$position_espace = strrpos($content, " "); 
				$content = substr($content, 0, $position_espace); 
				$content = $content."...";
			}
		else
			{
				$content = $post->post_content;
			}
		
			
		$post_content[] = $content;
		$thumb[] =  get_the_post_thumbnail( $post->ID,array($slider_bigthumb_x,$slider_bigthumb_y) );
		$thumb_mini[] =  get_the_post_thumbnail( $post->ID, array($slider_smallthumb_x,$slider_smallthumb_y) );
		
	endforeach;
	
	return array($post_ids,$post_title,$post_content,$thumb,$thumb_mini);
}

/* Rcuperation d'un post en fonction de son id */
function slider_get_post($id) {
	global $post, $tableposts, $tablepostmeta, $wp_version, $wpdb;
	$table = $wpdb->posts;
	$table .= ', ' . $wpdb->postmeta;
	$now = current_time('mysql');
	
	$query_suffix = "post_type = 'post' AND post_status = 'publish'";

	$post = $wpdb->get_row("SELECT * FROM $table WHERE ID=$id AND $query_suffix ORDER BY post_date DESC LIMIT 1");
	setup_postdata($post);
}

/* On ajoute le code aux headers ... */
add_action('wp_head', 'slider_styles');
add_action('admin_menu', 'slider_options_page');

?>